/*
**  Charset.h
**
**  Copyright (c) 2001, 2002
**
**  Author: Ludovic Marcotte <ludovic@Sophos.ca>
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**  
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
**  Lesser General Public License for more details.
**  
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef _Pantomime_H_Charset
#define _Pantomime_H_Charset

#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>

struct charset_code
{
  int code;
  unichar value;
};

@interface Charset : NSObject
{
  const struct charset_code *codes;
  int num_codes;
  
  int identity_map;
}

//
// the table most be sorted by code
//
- (id) initWithCodeCharTable: (const struct charset_code *)codes
                      length: (int)num_codes;

- (unichar) characterForCode: (int) theCode;
- (int) codeForCharacter: (unichar) theCharacter;
- (BOOL) characterIsInCharset: (unichar) theCharacter;

- (NSString *) name;

@end

#endif // _Pantomime_H_Charset
